/***********************************************************************
*
*     PROJECT: Drag & Drop sample with XbpStatic Objects (mouse & touch)
*  Programmer: J.A. Diego Kerejeta
*     Created: 08/27/2018
*
************************************************************************/

#include 'Xbp.ch'
#include 'Appevent.ch'
#include 'gra.ch'

#define GRA_CLR_XORANGE     16819711   // GraMakeRgbColor( { 255, 255, 153 } )
#define GRA_CLR_AZULON      26695467   // GraMakeRGBColor( { 43, 87, 151 } )
#define GRA_CLR_GRIS        31909606   // GraMakeRGBColor( { 230, 230, 230 } )

******************************
PROCEDURE Sample1( oDlgOwner )
******************************
LOCAL nEvent, mp1, mp2, oDlg, oXbp, oBT, oGreen, oRed, oOrange, oBox1, oBox2, nXPos, nYSize, oFocus
LOCAL aSize:= { 600, 460 }
LOCAL aPos := { Int( ( AppDesktop():currentSize()[ 1 ] - aSize[ 1 ] ) / 2 ), ;
                Int( ( AppDesktop():currentSize()[ 2 ] - aSize[ 2 ] ) / 2 ) }

oDlg := XbpDialog():new( AppDesktop(), oDlgOwner, aPos, aSize, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT }, ;
                         { XBP_PP_COMPOUNDNAME, '9.Arial Bold' } }, .F. )
   oDlg:title                   := 'Drag & Drop with XbpStatic Objects (mouse & touch)'
   oDlg:taskList                := .T.
   oDlg:drawingArea:clipChildren:= .T.
   oDlg:create()

oBox1:= XbpStatic():new()
   oBox1:type        := XBPSTATIC_TYPE_GROUPBOX
   oBox1:caption     := 'Drag Area'
   oBox1:clipChildren:= .T.
   oBox1:create( oDlg:drawingArea,, { 20, 20 }, { 145, oDlg:drawingArea:currentSize()[ 2 ] - 40 } )

oBT:= BotActivi():new()
   oBT:caption:= 'Drag' + Chr( 10 ) + 'object'
   oBT:nClrBG := GRA_CLR_AZULON
   oBT:nClrFG := GRA_CLR_WHITE
   oBT:create( oBox1,, { 10, 20 }, { 100, 100 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT }, ;
               { XBP_PP_BGCLR, GRA_CLR_AZULON }, { XBP_PP_FGCLR, GRA_CLR_WHITE } } )

nXPos := Int( oDlg:drawingArea:currentSize()[ 2 ] / 2 ) - 15
nYSize:= Int( oDlg:drawingArea:currentSize()[ 2 ] / 3 )

oGreen:= BotActivi():new()
   oGreen:caption:= 'b' + Chr( 10 ) + 'r' + Chr( 10 ) + 'u' + Chr( 10 ) + 's' + Chr( 10 ) + 'h'
   oGreen:nClrBG:= oGreen:_nClr:= GRA_CLR_GREEN
   oGreen:bValidateDrag:= {|| Len( oBox2:childList() ) > 0 }
   oGreen:create( oDlg:drawingArea,, { nXPos, 0          }, { 30, nYSize }, { { XBP_PP_BGCLR, GRA_CLR_GREEN   } } )

oRed:= BotActivi():new()
   oRed:caption:= oGreen:caption
   oRed:nClrBG := oRed:_nClr:= GRA_CLR_RED
   oRed:bValidateDrag:= oGreen:bValidateDrag
   oRed:create( oDlg:drawingArea,, { nXPos, nYSize     }, { 30, nYSize }, { { XBP_PP_BGCLR, GRA_CLR_RED     } } )

oOrange:= BotActivi():new()
   oOrange:caption:= oGreen:caption
   oOrange:nClrBG := oOrange:_nClr:= GRA_CLR_XORANGE
   oOrange:bValidateDrag:= oGreen:bValidateDrag
   oOrange:create( oDlg:drawingArea,, { nXPos, nYSize * 2 }, { 30, nYSize }, { { XBP_PP_BGCLR, GRA_CLR_XORANGE } } )

oBox2:= XbpStatic():new()
   oBox2:type        := XBPSTATIC_TYPE_GROUPBOX
   oBox2:caption     := 'Drop Area'
   oBox2:clipChildren:= .T.
   oBox2:create( oDlg:drawingArea,, { nXPos + 60 , 20 }, { 250, oDlg:drawingArea:currentSize()[ 2 ] - 40 } )

oBT:registraReceptor( oGreen,,  {|oEmisor| oEmisor:setDragColor( oEmisor, GRA_CLR_GREEN   ) } )
oBT:registraReceptor( oRed,,    {|oEmisor| oEmisor:setDragColor( oEmisor, GRA_CLR_RED     ) } )
oBT:registraReceptor( oOrange,, {|oEmisor| oEmisor:setDragColor( oEmisor, GRA_CLR_XORANGE ) } )

oBT:registraReceptor( oBox2, {|oEmisor, oReceptor| DropBox2( oEmisor, oReceptor, oBox1, oGreen, oRed, oOrange ) } )

oDlg:setModalState( XBP_DISP_APPMODAL )
oDlg:show()
oFocus:= SetAppFocus( oDlg )

DO WHILE nEvent <> xbeP_Close
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
oDlg:setModalState( XBP_DISP_MODELESS )
oDlg:destroy()
SetAppFocus( oFocus )
RETURN

*****************************************************************************
STATIC PROCEDURE DropBox2( oEmisor, oReceptor, oBox1, oGreen, oRed, oOrange )
*****************************************************************************
LOCAL nChilds:= Len( oReceptor:childList() )
LOCAL oBT

oBT:= BotActivi():new()
   oBT:caption:= oEmisor:getDragData() + Chr( 10 ) + '#' + LTrim( Str( nChilds + 1 ) )
   oBT:nClrBG    := oEmisor:nClr
   oBT:nClrFG    := GRA_CLR_BLACK
   oBT:create( oReceptor,, { 10, IIF( nChilds = 0, 20, 20 + 104 * nChilds ) }, { 100, 100 }, ;
               { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT }, { XBP_PP_BGCLR, oEmisor:nClr }, { XBP_PP_FGCLR, GRA_CLR_BLACK } } )

oBT:registraReceptor( oBox1, {|oEmisor, oReceptor| DropBox1( oEmisor, oReceptor, oGreen, oRed, oOrange ) } )

oGreen:registraReceptor(  oBT, {|oEmisor, oReceptor| DropBrush( oEmisor, oReceptor, oGreen, oRed, oOrange ) } )
oRed:registraReceptor(    oBT, {|oEmisor, oReceptor| DropBrush( oEmisor, oReceptor, oGreen, oRed, oOrange ) } )
oOrange:registraReceptor( oBT, {|oEmisor, oReceptor| DropBrush( oEmisor, oReceptor, oGreen, oRed, oOrange ) } )

IF nChilds = 2 ; oEmisor:hide() ; ENDIF
RETURN

**********************************************************************
STATIC PROCEDURE DropBox1( oEmisor, oReceptor, oGreen, oRed, oOrange )
**********************************************************************
LOCAL aChilds:= oEmisor:setParent():childList()
LOCAL nPos   := AScan( aChilds, oEmisor )
LOCAL nLen   := Len( aChilds )
LOCAL nCont, aPos

oGreen:eliminaReceptor( oEmisor )
oRed:eliminaReceptor( oEmisor )
oOrange:eliminaReceptor( oEmisor )

oEmisor:destroy()

IF nPos < nLen
   FOR nCont:= nPos + 1 TO nLen
      aPos:= aChilds[ nCont ]:currentPos()
      aPos[ 2 ]-= 104
      aChilds[ nCont ]:setPos( aPos )
   NEXT
ENDIF

IF ! oReceptor:childList()[ 1 ]:isVisible() ; oReceptor:childList()[ 1 ]:show() ; ENDIF
RETURN

***********************************************************************
STATIC PROCEDURE DropBrush( oEmisor, oReceptor, oGreen, oRed, oOrange )
***********************************************************************
IF oEmisor:nClrBG # oReceptor:nClrBG
   oReceptor:setColorBG( oEmisor:nClrBG )
   oReceptor:nClrBG:= oEmisor:nClrBG
ENDIF
RETURN

**************************************************
STATIC CLASS BotActivi FROM XbpStatic, DragAndDrop
**************************************************
PROTECTED:
   INLINE METHOD createDrag( aPos, aRect )
   ***************************************
      LOCAL aSize:= { aRect[ 3 ] - aRect[ 1 ], aRect[ 4 ] - aRect[ 2 ] }
      LOCAL oXbp

      ::nClr:= ::_nClr

      ::oDrag:= XbpStatic():new( AppDeskTop(),, aPos, aSize, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT }, ;
                                 { XBP_PP_FGCLR, GRA_CLR_BLACK }, { XBP_PP_BGCLR, ::nClr } }, .F. )
         ::oDrag:clipChildren:= .T.
         ::oDrag:create()

      oXbp:= XbpStatic():new( ::oDrag,, { 0, 0 }, aSize, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT }, { XBP_PP_FGCLR, GRA_CLR_BLACK }, ;
                                                           { XBP_PP_BGCLR, ::nClr } } )
         oXbp:options     := XBPALIGN_WORDBREAK + XBPALIGN_HCENTER
         oXbp:caption     := ::caption
         oXbp:clipSiblings:= .T.
         oXbp:create()

      ::createPointer( ::oDrag )

      ::oDrag:show()
   RETURN self

EXPORTED:
   VAR nClrFG
   VAR nClrBG
   VAR nClr
   VAR _nClr

   INLINE METHOD Destroy
   *********************
      ::XbpStatic:destroy() ; ::DragAndDrop:destroy()
      ::nClrFG:= ::nClrBG:= ::nClr:= ::_nClr:= nil
   RETURN self

   INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *****************************************************************
      ::DragAndDrop:init()
      ::XbpStatic:Init( oParent, oOwner, aPos, aSize, aPP, lVisible )
      ::options:= XBPALIGN_WORDBREAK + XBPALIGN_HCENTER
      ::nClrFG := GRA_CLR_WHITE
      ::nClr   := GRA_CLR_GRIS
      ::_nClr  := ::nClr
   RETURN self

   INLINE METHOD LbDown( aPos )
   ****************************
      ::aPosClick:= ::getcursorPos()

      IF ! ::XbpStatic:hasInputFocus() ; SetAppFocus( ::XbpStatic ) ; ENDIF
      IF ! ::drag( aPos )              ; ::XbpStatic:LbDown( aPos ) ; ENDIF
   RETURN self

   INLINE METHOD SetDragColor( nClrFG, nClrBG )
   *******************************************
      ::oDrag:lockUpdate( .T. )
      ::oDrag:setColorBG( nClrBG )
      ::oDrag:childList()[ 1 ]:setColorFG( nClrFG )
      ::oDrag:childList()[ 1 ]:setColorBG( nClrBG )
      ::oDrag:childList()[ 2 ]:setColorBG( -255 )
      ::oDrag:lockUpdate( .F. )
      ::oDrag:invalidateRect()
      ::nClr:= nClrBG
   RETURN self

   INLINE METHOD GetDragData ; RETURN ::caption
   *************************   
ENDCLASS


