/*************************************************
*
*     PROJECT: Drag & Drop Samples (mouse & touch)
*  Programmer: J.A. Diego Kerejeta
*     Created: 08/27/2018
*
**************************************************/

#include 'Appevent.ch'
#include 'Common.ch'
#include 'Gra.ch'
#include 'Xbp.ch'
#include 'Font.ch'

#define xbeP_Fin                  xbeP_User + 1

#define TIT_TESTS                'Tests'
#define TXT_TEST_1               'Drag&&Drop with XbpStatic'
#define TXT_TEST_2               'Drag&&Drop with XbpBrowse (keeping the standard drag)'
#define TXT_TEST_3               'Drag&&Drop with XbpBrowse (blocking the standard drag)'
#define TXT_MENU                 'Menu'
#define TXT_QUIT                 'Quit'
#define MSG_DBE_NOT_LOADED       ' database engine not loaded'
#define MSG_DBE_NOT_CREATED      ' database engine could not be created'


****************
PROCEDURE AppSys
****************
LOCAL oDlg

oDlg := XbpDialog():new( , , { 0, 0 }, { 790, 600 }, , .F. )
   oDlg:taskList                := .T.
   oDlg:close                   := {|u1, u2, obj| PostAppEvent( xbeP_Fin,,, obj ) }
   oDlg:border                  := XBPDLG_DLGBORDER
   oDlg:title                   := TIT_TESTS
   oDlg:drawingArea:clipChildren:= .T.
   oDlg:create()
   AppMenu( oDlg:menuBar() )
   oDlg:setFrameState( XBPDLG_FRAMESTAT_MAXIMIZED )

SetAppFocus( oDlg )
SetAppWindow( oDlg )
RETURN

*****************************
PROCEDURE AppMenu( oMenuBar )
*****************************
LOCAL oMenu

oMenu:= XbpMenu():new( oMenuBar )
   oMenu:title := TXT_MENU
   oMenu:create()
   oMenu:addItem( { TXT_TEST_1,  {|| Sample1( SetAppWindow() ) } } )
   oMenu:addItem( { TXT_TEST_2,  {|| Sample2( SetAppWindow(), .T. ) } } )
   oMenu:addItem( { TXT_TEST_3,  {|| Sample2( SetAppWindow(), .F. ) } } )
   oMenu:addItem( { NIL, NIL, XBPMENUBAR_MIS_SEPARATOR, 0} )
   oMenu:addItem( { TXT_QUIT,  {|| PostAppEvent( xbeP_Fin ) } } )
   oMenuBar:addItem( { oMenu, } )
RETURN

**************
PROCEDURE Main
**************
LOCAL nEvent, mp1, mp2, oXbp

DO WHILE nEvent <> xbeP_Fin
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
QUIT
RETURN

